package httpconnection;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.methods.PostMethod;

public class Client
{
  private HttpClient client;
  private PostMethod method;
  
  public Client()
  {
    this.client = new HttpClient();
  }
  
  public int modelExist(String url, String xmlcode, String modelname, String modeltype, String modelversion)
  {
    this.method = new PostMethod(url + "ModelExistServlet");
    this.method.addParameter("xmlcode", xmlcode);
    this.method.addParameter("modelname", modelname);
    this.method.addParameter("modeltype", modeltype);
    this.method.addParameter("modelversion", modelversion);
    try
    {
      int returnCode = this.client.executeMethod(this.method);
      if (returnCode == 501)
      {
        System.err.println("The Post method is not implemented by this URI");
        
        this.method.getResponseBodyAsString();
        return -1;
      }
      String s = this.method.getResponseBodyAsString();
      if (s.equals("true")) {
        return 1;
      }
      return 0;
    }
    catch (Exception e)
    {
      System.err.println(e.getMessage());
    }
    return -1;
  }
  
  public String importModel(String url, String xmlcode, String modelname, String modeltype, String modelversion, String override)
  {
    this.method = new PostMethod(url + "XmlImportServlet");
    this.method.addParameter("xmlcode", xmlcode);
    this.method.addParameter("modelname", modelname);
    this.method.addParameter("modeltype", modeltype);
    this.method.addParameter("modelversion", modelversion);
    this.method.addParameter("override", override);
    try
    {
      int returnCode = this.client.executeMethod(this.method);
      if (returnCode == 501)
      {
        System.err.println("The Post method is not implemented by this URI");
        
        this.method.getResponseBodyAsString();
        return "The Post method is not implemented by this URI";
      }
      return this.method.getResponseBodyAsString();
    }
    catch (Exception e)
    {
      System.err.println(e.getMessage());
      return "Error: " + e.getMessage();
    }
  }
}
