package httpconnection;

import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.methods.PostMethod;

public class Client_Seq
{
  private HttpClient client;
  private PostMethod method;
  
  public Client_Seq()
  {
    this.client = new HttpClient();
  }
  
  public String importModel(String url, String xmlcode, String modelname, String modeltype, String modelversion)
  {
    this.method = new PostMethod(url + "XmlImportServlet_Seq");
    this.method.addParameter("xmlcode", xmlcode);
    this.method.addParameter("modelname", modelname);
    this.method.addParameter("modeltype", modeltype);
    this.method.addParameter("modelversion", modelversion);
    this.method.getParams().setParameter("http.socket.timeout", new Integer(5000));
    try
    {
      int returnCode = this.client.executeMethod(this.method);
      if (returnCode == 501)
      {
        System.err.println("The Post method is not implemented by this URI");
        
        this.method.getResponseBodyAsString();
        this.method.releaseConnection();
        return "The Post method is not implemented by this URI";
      }
      String s = this.method.getResponseBodyAsString();
      this.method.releaseConnection();
      
      return s;
    }
    catch (Exception e)
    {
      System.err.println(e.getMessage());
      return "Error: " + e.getMessage();
    }
  }
}
