package org.omilab.semfis5x.base;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;

public class Instance {

	  @XmlAttribute(name="name")
	  private String name;
	  @XmlAttribute(name="class")
	  private String adoclass;
	  @XmlElement(name="ATTRIBUTE")
	  private List<Attribute> attributes;
	  @XmlElement(name="RECORD")
	  private List<Record> records;
	  @XmlElement(name="INTERREF")
	  private List<Interrefs> interrefs;
	  private static int anz = 0;
	  
	  public Instance()
	  {
	    this("Unnamed" + anz, "Class");
	  }
	  
	  public Instance(String name, String adoclass)
	  {
	    this(name, adoclass, new ArrayList<Attribute>(), new ArrayList<Record>(), new ArrayList<Interrefs>());
	  }
	  
	  public Instance(String name, String adoclass, List<Attribute> attributes, List<Record> records, List<Interrefs> interrefs)
	  {
	    this.name = name;
	    this.adoclass = adoclass;
	    this.attributes = attributes;
	    this.records = records;
	    this.interrefs = interrefs;
	    
	    anz += 1;
	  }
	  
	  public void setName(String name)
	  {
	    this.name = name;
	  }
	  
	  public void setAdoclass(String adoclass)
	  {
	    this.adoclass = adoclass;
	  }
	  
	  public void setAttributes(List<Attribute> attributes)
	  {
	    this.attributes = attributes;
	  }
	  
	  public void setRecords(List<Record> records)
	  {
	    this.records = records;
	  }
	  
	  public void setInterrefs(List<Interrefs> interrefs)
	  {
	    this.interrefs = interrefs;
	  }
	  
	  public void addAttribute(Attribute attribute)
	  {
	    this.attributes.add(attribute);
	  }
	  
	  public Attribute removeAttribute(int index)
	  {
	    return (Attribute)this.attributes.remove(index);
	  }
	  
	  public void addRecord(Record record)
	  {
	    this.records.add(record);
	  }
	  
	  public Record removeRecord(int index)
	  {
	    return (Record)this.records.remove(index);
	  }
	  
	  public void addInterref(Interrefs interref)
	  {
	    this.interrefs.add(interref);
	  }
	  
	  public Interrefs removeInterref(int index)
	  {
	    return (Interrefs)this.interrefs.remove(index);
	  }
}



/*
 * 
 * 
 * 
				myarrayList
				myarrayListProperties
				myarrayListIndivduals
				
				listModel.clear();
				listModelProperties.clear();
				listModelIndividual.clear();
				
				
				mylist
				mylistProperties
				mylistIndividuals
				
				werte
				werteproberties
				werteindividuals
				
				
				
				*/
