package org.omilab.semfis5x.base;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;

public class Interrefs {

	  @XmlAttribute(name="name")
	  private String name;
	  @XmlElement(name="IREF")
	  private List<Iref> referenzen;
	  
	  public Interrefs()
	  {
	    this(null);
	  }
	  
	  public Interrefs(String name)
	  {
	    this(name, new ArrayList<Iref>());
	  }
	  
	  public Interrefs(String name, List<Iref> referenzen)
	  {
	    this.name = name;
	    this.referenzen = referenzen;
	  }
	  
	  public void setName(String name)
	  {
	    this.name = name;
	  }
	  
	  public void setReferenzen(List<Iref> referenzen)
	  {
	    this.referenzen = referenzen;
	  }
	  
	  public void addReferenz(Iref referenz)
	  {
	    this.referenzen.add(referenz);
	  }
	  
	  public Iref removeReferenz(int index)
	  {
	    return (Iref)this.referenzen.remove(index);
	  }
	  
	  public int countRefs()
	  {
	    return this.referenzen.size();
	  }
}
