package org.omilab.semfis5x.base;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;

public class Model {

	  @XmlAttribute(name="id")
	  private String id;
	  @XmlAttribute(name="name")
	  private String name;
	  @XmlAttribute(name="version")
	  private String version;
	  @XmlAttribute(name="modeltype")
	  private String modeltype;
	  @XmlAttribute(name="libtype")
	  private String libtype;
	  @XmlAttribute(name="applib")
	  private String applib;
	  @XmlElement(name="ATTRIBUTE")
	  @XmlElementWrapper(name="MODELATTRIBUTES")
	  private List<Attribute> modelattributes;
	  @XmlElement(name="INSTANCE")
	  private List<Instance> objekte;
	  private static int anz = 0;
	  
	  public Model()
	  {
	    this("Unnamed" + anz);
	  }
	  
	  public Model(String name)
	  {
	    this(name, "");
	  }
	  
	  public Model(String name, String version)
	  {
	    this(null, name, version);
	  }
	  
	  public Model(String id, String name, String version)
	  {
	    this(id, name, version, "Ontology Model", "bp", "SeMFIS_0.3_ADOxx_1.3_Dynamic_library", new ArrayList<Attribute>(), new ArrayList<Instance>());
	  }
	  
	  public Model(String id, String name, String version, String modeltype, String libtype, String applib, List<Attribute> modelattributes, List<Instance> objekte)
	  {
	    this.id = id;
	    this.name = name;
	    this.version = version;
	    this.modeltype = modeltype;
	    this.libtype = libtype;
	    this.applib = applib;
	    this.modelattributes = modelattributes;
	    this.objekte = objekte;
	    
	    anz += 1;
	  }
	  
	  public void setId(String id)
	  {
	    this.id = id;
	  }
	  
	  public void setName(String name)
	  {
	    this.name = name;
	  }
	  
	  public void setVersion(String version)
	  {
	    this.version = version;
	  }
	  
	  public void setModeltype(String modeltype)
	  {
	    this.modeltype = modeltype;
	  }
	  
	  public void setLibtype(String libtype)
	  {
	    this.libtype = libtype;
	  }
	  
	  public void setApplib(String applib)
	  {
	    this.applib = applib;
	  }
	  
	  public void setModelattributes(List<Attribute> modelattributes)
	  {
	    this.modelattributes = modelattributes;
	  }
	  
	  public void setObjekte(List<Instance> objekte)
	  {
	    this.objekte = objekte;
	  }
	  
	  public void addModelattribute(Attribute modelattribute)
	  {
	    this.modelattributes.add(modelattribute);
	  }
	  
	  public Attribute removeModelattribute(int index)
	  {
	    return (Attribute)this.modelattributes.remove(index);
	  }
	  
	  public void addInstance(Instance modelattribute)
	  {
	    this.objekte.add(modelattribute);
	  }
	  
	  public Instance removeInstance(int index)
	  {
	    return (Instance)this.objekte.remove(index);
	  }
}
