package org.omilab.semfis5x.base;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;

public class Record {

	  @XmlAttribute(name="name")
	  private String name;
	  @XmlElement(name="ROW")
	  private List<Row> rows;
	  
	  public Record()
	  {
	    this(null, new ArrayList<Row>());
	  }
	  
	  public Record(String name)
	  {
	    this(name, new ArrayList<Row>());
	  }
	  
	  public Record(String name, List<Row> rows)
	  {
	    this.name = name;
	    this.rows = rows;
	  }
	  
	  public void setName(String name)
	  {
	    this.name = name;
	  }
	  
	  public void setRows(List<Row> rows)
	  {
	    this.rows = rows;
	  }
	  
	  public void addRow(Row row)
	  {
	    row.setIndex(this.rows.size() + 1);
	    this.rows.add(row);
	  }
	  
	  public Row removeRow(int index)
	  {
	    Row temp = (Row)this.rows.remove(index);
	    updateRowNumbers();
	    return temp;
	  }
	  
	  public int countRows()
	  {
	    return this.rows.size();
	  }
	  
	  private void updateRowNumbers()
	  {
	    for (int i = 0; i < this.rows.size(); i++) {
	      ((Row)this.rows.get(i)).setIndex(i + 1);
	    }
	  }
}
