package org.omilab.semfis5x.base;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlRootElement;

@XmlRootElement(name="ADOXML")
public class RootElement
{
  @XmlAttribute(name="version", required=true)
  private String version;
  @XmlAttribute(name="date", required=true)
  private String date;
  @XmlAttribute(name="time", required=true)
  private String time;
  @XmlAttribute(name="database", required=true)
  private String database;
  @XmlAttribute(name="username", required=true)
  private String username;
  @XmlAttribute(name="adoversion", required=true)
  private String adoversion;
  @XmlElement(name="MODEL")
  @XmlElementWrapper(name="MODELS")
  private List<Model> models;
  
  public RootElement()
  {
    this("3.1", "01.01.2008", "13:00", null, null, "Version 3.81", new ArrayList<Model>());
  }
  
  public RootElement(String database, String username)
  {
    this("3.1", "01.01.2008", "13:00", database, username, "Version 3.81", new ArrayList<Model>());
  }
  
  public RootElement(String database, String username, List<Model> models)
  {
    this("3.1", "01.01.2008", "13:00", database, username, "Version 3.81", models);
  }
  
  public RootElement(String database, String username, Model model)
  {
    this("3.1", "01.01.2008", "13:00", database, username, "Version 3.81", model);
  }
  
  public RootElement(String version, String date, String time, String database, String username, String adoversion, List<Model> models)
  {
    if (version == null) {
      version = "3.1";
    }
    if (date == null) {
      date = "01.01.2008";
    }
    if (time == null) {
      time = "13:00";
    }
    if (adoversion == null) {
      adoversion = "Version 3.81";
    }
    this.version = version;
    this.date = date;
    this.time = time;
    this.database = database;
    this.username = username;
    this.adoversion = adoversion;
    
    this.models = models;
  }
  
  public RootElement(String version, String date, String time, String database, String username, String adoversion, Model model)
  {
    if (version == null) {
      version = "3.1";
    }
    if (date == null) {
      date = "01.01.2008";
    }
    if (time == null) {
      time = "13:00";
    }
    if (database == null) {
      database = "adonisdb";
    }
    if (username == null) {
      username = "John Doe";
    }
    if (adoversion == null) {
      adoversion = "Version 3.81";
    }
    this.version = version;
    this.date = date;
    this.time = time;
    this.database = database;
    this.username = username;
    this.adoversion = adoversion;
    
    this.models = new ArrayList<Model>();
    this.models.add(model);
  }
  
  public void setVersion(String version)
  {
    this.version = version;
  }
  
  public void setDate(String date)
  {
    this.date = date;
  }
  
  public void setTime(String time)
  {
    this.time = time;
  }
  
  public void setDatabase(String database)
  {
    this.database = database;
  }
  
  public void setUsername(String username)
  {
    this.username = username;
  }
  
  public void setAdoversion(String adoversion)
  {
    this.adoversion = adoversion;
  }
  
  public void setModels(List<Model> models)
  {
    this.models = models;
  }
  
  public void addModel(Model models)
  {
    this.models.add(models);
  }
  
  public void removeModel(int index)
  {
    this.models.remove(index);
  }
}
