package org.omilab.semfis5x.base;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;

public class Row {

	  @XmlAttribute(name="number")
	  private int index;
	  @XmlElement(name="ATTRIBUTE")
	  private List<Attribute> attributes;
	  @XmlElement(name="INTERREF")
	  private List<Interrefs> interrefs;
	  
	  public Row()
	  {
	    this(0);
	  }
	  
	  public Row(int index)
	  {
	    this(index, new ArrayList<Attribute>(), new ArrayList<Interrefs>());
	  }
	  
	  public Row(int index, List<Attribute> attributes, List<Interrefs> interrefs)
	  {
	    this.index = index;
	    this.attributes = attributes;
	    this.interrefs = interrefs;
	  }
	  
	  public void setIndex(int index)
	  {
	    this.index = index;
	  }
	  
	  public void setAttributes(List<Attribute> attributes)
	  {
	    this.attributes = attributes;
	  }
	  
	  public void setInterrefs(List<Interrefs> interrefs)
	  {
	    this.interrefs = interrefs;
	  }
	  
	  public void addAttribute(Attribute attribute)
	  {
	    this.attributes.add(attribute);
	  }
	  
	  public Attribute removeAttribute(int index)
	  {
	    return (Attribute)this.attributes.remove(index);
	  }
	  
	  public void addInterref(Interrefs interref)
	  {
	    this.interrefs.add(interref);
	  }
	  
	  public Interrefs removeInterref(int index)
	  {
	    return (Interrefs)this.interrefs.remove(index);
	  }
	  
}
