package org.omilab.semfis5x.plugin;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.ListCellRenderer;


class IconListRenderer extends JLabel implements ListCellRenderer<Object> {
	  /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static final Color HIGHLIGHT_COLOR = new Color(0, 0, 128);

	  public IconListRenderer() {
	    setOpaque(true);
	    setIconTextGap(12);
	  }

	  public Component getListCellRendererComponent(JList<?> list, Object value,
	      int index, boolean isSelected, boolean cellHasFocus) {
	    ListItem entry = (ListItem) value;
	    setText(entry.getName());
	    setIcon(entry.getImage());
	    if (isSelected) {
	      setBackground(HIGHLIGHT_COLOR);
	      setForeground(Color.white);
	    } else {
	      setBackground(Color.white);
	      setForeground(Color.black);
	    }
	    return this;
	  }
	}
/*
public class IconListRenderer extends DefaultListCellRenderer {

	private Map<Object, ImageIcon> icons = null;

	public IconListRenderer(Map<Object, ImageIcon> icons) {
		this.icons = icons;
	}

	@Override
	public Component getListCellRendererComponent(JList list, Object value,
			int index, boolean isSelected, boolean cellHasFocus) {

		// Get the renderer component from parent class

		JLabel label = (JLabel) super.getListCellRendererComponent(list, value,
				index, isSelected, cellHasFocus);

		// Get icon to use for the list item value

		Icon icon = icons.get(value);

		// Set icon to display for value

		label.setIcon(icon);
		return label;
	}
}
*/