package org.omilab.semfis5x.plugin;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
//import java.awt.TextArea;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.apache.log4j.Logger;
import org.omilab.semfis5x.export.DefaultExportImplementation;
import org.protege.editor.owl.ui.view.AbstractOWLViewComponent;
import org.semanticweb.owlapi.formats.PrefixDocumentFormat;
import org.semanticweb.owlapi.model.OWLAnnotationProperty;
import org.semanticweb.owlapi.model.OWLClass;
import org.semanticweb.owlapi.model.OWLDataProperty;
import org.semanticweb.owlapi.model.OWLIndividual;
import org.semanticweb.owlapi.model.OWLNamedIndividual;
import org.semanticweb.owlapi.model.OWLObjectProperty;
import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.model.OWLProperty;



/**
 * Diese Klasse dient als Einstiegspunkt und dient der Visualisierung, fuer den Export wird die Methode export der Klasse DefaultExportImplementation aufgerufen
 * @author Manuel Gall, Claudia Gratz
 *
 */
public class Tab extends AbstractOWLViewComponent {
	private static final long serialVersionUID = -4515710047558710080L;

	private static final Logger log = Logger.getLogger(Tab.class);
	public JTextField tf_path  = new JTextField();
	public JTextField tf_modelname = new JTextField();
	public JTextField tf_modelversion = new JTextField();
//	private OWLModelManager owlmodel;
	private DefaultExportImplementation export;

	// private Metrics metricsComponent;

	@Override
	protected void initialiseOWLView() throws Exception {
		

	    
		// Lyout festlegen
		setLayout(new BorderLayout());

		
		// Die Textareas fuer Classes, Properties und Instances
//		final TextArea output = new TextArea();
//		final TextArea output2 = new TextArea();
//		final TextArea output3 = new TextArea();

		// Die Aktive Ontologie holen, wird benoetigt damit man auf die einzelnen elemente wie Classes ... zugreifen kann.
		Set<OWLOntology> test = getOWLModelManager().getActiveOntologies();
		Iterator<OWLOntology> ontos = test.iterator();
        OWLOntology xy = ontos.next();
		final OWLOntology ontology = xy;
		
		// wird fuer den Namespace benoetigt
		PrefixDocumentFormat manager = getOWLModelManager().getOWLOntologyManager().getOntologyFormat(ontology).asPrefixOWLOntologyFormat();
		final PrefixDocumentFormat prefixmanager = manager; 
		
		// Der Aktuallisieren Button, aktuallisiert die Classes, Instances und Properties welche dem User zur Auswahl stehen.
		JButton button = new JButton("Load into Plugin");

		// In diese Arrays werden jeweils Classes, Instances und Properties gespeichert.
		final ArrayList<ListItem> myarrayList = new ArrayList<ListItem>();
		final ArrayList<ListItem> myarrayListIndivduals = new ArrayList<ListItem>();
		final ArrayList<ListItem> myarrayListProperties = new ArrayList<ListItem>();

		// In diesen DefaulListModels werden jeweils Classes, Instances und Properties zur Auswahl angeboten.
		final DefaultListModel<ListItem> listModel = new DefaultListModel<ListItem>();
		final DefaultListModel<ListItem> listModelIndividual = new DefaultListModel<ListItem>();
		final DefaultListModel<ListItem> listModelProperties = new DefaultListModel<ListItem>();
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				// Leeren der Listen
				listModel.clear();
				listModelIndividual.clear();
				listModelProperties.clear();
				
				// Hole alle OWL Klassen, gehe sie darauf hin durch und fuege sie der Liste hinzu. Beruecksichtige dabei noch ob die Variable bereits einmal gespeichert wurde oder nicht.
				Set<OWLClass> classes = getOWLModelManager().getOWLEntityFinder().getMatchingOWLClasses("*");
				Iterator<OWLClass> iterator = classes.iterator();
				int i = 0;
				while (iterator.hasNext()) {
					OWLClass myitem = iterator.next();
					ListItem item = new ListItem(myitem.getIRI().getShortForm(), myitem.getIRI(), myitem);
					boolean set = true;
					for (int d = 0; d < myarrayList.size(); ++d) {
						if (myarrayList.get(d).toString().equals(item.toString())) {
							set = false;
							listModel.add(i++, myarrayList.get(d));
						}
					}
					if (set) {
						myarrayList.add(item);
						listModel.add(i++, item);
					}
				}


				// Hole alle Object Properties, gehe sie darauf hin durch und fuege sie der Liste hinzu. Beruecksichtige dabei noch ob die Variable bereits einmal gespeichert wurde oder nicht.
				Set<OWLObjectProperty> properties = getOWLModelManager().getOWLEntityFinder().getMatchingOWLObjectProperties("*");
				Iterator<OWLObjectProperty> iteratorprop = properties.iterator();
				i = 0;
				while (iteratorprop.hasNext()) {
					OWLObjectProperty myitem = iteratorprop.next();
					ListItem item = new ListItem(myitem.getIRI().getShortForm(),	myitem.getIRI(), myitem);
					boolean set = true;
					for (int d = 0; d < myarrayListProperties.size(); ++d) {
						if (myarrayListProperties.get(d).toString().equals(item.toString())) {
							set = false;
							listModelProperties.add(i++, myarrayListProperties.get(d));
						}
					}
					if (set) {
						myarrayListProperties.add(item);
						listModelProperties.add(i++, item);
					}
				}


				// Hole alle Data Properties, gehe sie darauf hin durch und fuege sie der Liste hinzu. Beruecksichtige dabei noch ob die Variable bereits einmal gespeichert wurde oder nicht.
				Set<OWLDataProperty> propertiesdata = getOWLModelManager().getOWLEntityFinder().getMatchingOWLDataProperties("*");
				Iterator<OWLDataProperty> iteratorpropdata = propertiesdata.iterator();
				i = 0;
				while (iteratorpropdata.hasNext()) {
					OWLDataProperty myitem = iteratorpropdata.next();
					ListItem item = new ListItem(myitem.getIRI().getShortForm(),	myitem.getIRI(), myitem);
					boolean set = true;
					for (int d = 0; d < myarrayListProperties.size(); ++d) {
						if (myarrayListProperties.get(d).toString().equals(item.toString())) {
							set = false;
							listModelProperties.add(i++, myarrayListProperties.get(d));
						}
					}
					if (set) {
						myarrayListProperties.add(item);
						listModelProperties.add(i++, item);
					}
				}
				

				// Hole alle Annotation Properties, gehe sie darauf hin durch und fuege sie der Liste hinzu. Beruecksichtige dabei noch ob die Variable bereits einmal gespeichert wurde oder nicht.
				Set<OWLAnnotationProperty> propertiesanno = getOWLModelManager().getOWLEntityFinder().getMatchingOWLAnnotationProperties("*");
				Iterator<OWLAnnotationProperty> iteratorpropanno = propertiesanno.iterator();
				i = 0;
				while (iteratorpropanno.hasNext()) {
					OWLAnnotationProperty myitem = iteratorpropanno.next(); 
					ListItem item = new ListItem(myitem.getIRI().getShortForm(),	myitem.getIRI(), myitem);
					boolean set = true;
					for (int d = 0; d < myarrayListProperties.size(); ++d) {
						if (myarrayListProperties.get(d).toString().equals(item.toString())) {
							set = false;
							listModelProperties.add(i++, myarrayListProperties.get(d));
						}
					}
					if (set) {
						myarrayListProperties.add(item);
						listModelProperties.add(i++, item);
					}
				}
				

				// Hole alle Individuals, gehe sie darauf hin durch und fuege sie der Liste hinzu. Beruecksichtige dabei noch ob die Variable bereits einmal gespeichert wurde oder nicht.
				boolean fullRegExp = true;
				Set<OWLNamedIndividual> indviduals = getOWLModelManager().getOWLEntityFinder().getMatchingOWLIndividuals(".+", fullRegExp  );
				Iterator<OWLNamedIndividual> iteratorindividuals = indviduals.iterator();
				i = 0;
				while (iteratorindividuals.hasNext()) {
					OWLNamedIndividual myitem = iteratorindividuals.next();
					ListItem item = new ListItem(myitem.getIRI().getShortForm(),	myitem.getIRI(), myitem);
					boolean set = true;
					for (int d = 0; d < myarrayListIndivduals.size(); ++d) {
						if (myarrayListIndivduals.get(d).toString().equals(item.toString())) {
							set = false; 
							listModelIndividual.add(i++, myarrayListIndivduals.get(d));
						}
					}
					if (set) {
						myarrayListIndivduals.add(item);
						listModelIndividual.add(i++, item);
					}
				}
			}
		});

		
		// erzeuge die Horizontale Ausgabe mit den Ganzen Buttons
		JPanel listPane = new JPanel();
		listPane.setLayout(new BoxLayout(listPane, BoxLayout.PAGE_AXIS));
		JPanel listPaneWagrecht = new JPanel();

		JPanel listPane1 = new JPanel();
		listPane1.setAlignmentY(TOP_ALIGNMENT);
		listPane1.setLayout(new BoxLayout(listPane1, BoxLayout.PAGE_AXIS));
		JLabel label = new JLabel("Update:");
		listPane1.add(label);
		listPane1.add(button);

		JPanel listPane2 = new JPanel();
		listPane2.setAlignmentY(TOP_ALIGNMENT);
		listPane2.setLayout(new BoxLayout(listPane2, BoxLayout.PAGE_AXIS));
		JLabel label2 = new JLabel("Select:");
		JButton button2 = new JButton("Select all");
		JButton button3 = new JButton("De-select all");
		listPane2.add(label2);

		JPanel listPane3 = new JPanel();
		listPane3.setAlignmentY(TOP_ALIGNMENT);
		listPane3.setLayout(new BoxLayout(listPane3, BoxLayout.PAGE_AXIS));
		JLabel label3 = new JLabel("Mark for Export:");
		JButton button4 = new JButton("Mark selection");
		JButton button5 = new JButton("Mark all");
		listPane3.add(label3);

		JPanel listPane4 = new JPanel();
		listPane4.setAlignmentY(TOP_ALIGNMENT);
		listPane4.setLayout(new BoxLayout(listPane4, BoxLayout.PAGE_AXIS));
		JLabel label4 = new JLabel("Un-mark for Export:");
		JButton button6 = new JButton("Un-mark selection");
		JButton button7 = new JButton("Un-mark all");
		listPane4.add(label4);

		JPanel listPane5 = new JPanel();
		listPane5.setAlignmentY(TOP_ALIGNMENT);
		listPane5.setLayout(new BoxLayout(listPane5, BoxLayout.PAGE_AXIS));
		JLabel label5 = new JLabel("Execute");
		JButton button8 = new JButton("Export");
		listPane5.add(label5);
		
		
		

		// erzeuge die Horizontale Ausgabe mit den Feldern fuer das Exportieren als XML
		JPanel listPaneAusgabe = new JPanel();
		listPaneAusgabe.setAlignmentY(TOP_ALIGNMENT);
		listPaneAusgabe.setLayout(new BoxLayout(listPaneAusgabe, BoxLayout.LINE_AXIS));
		listPaneAusgabe.setSize(10, 10);
		JLabel labelModelname = new JLabel ("Model name: ");
		JLabel labelModelnummer = new JLabel ("Version: ");
		JLabel labelSpeicherort = new JLabel("Save as: ");
		JButton browse = new JButton("Select file");
		
		// Textfelder maximale groesse damit sie nicht den ganzen platz fuer sich beanspruchen
		tf_modelname.setMaximumSize(new Dimension(100,20)  );
		tf_modelversion.setMaximumSize( new Dimension(100,20) );
		tf_path.setMaximumSize( new Dimension(120,20) );
		
		
		listPaneAusgabe.add(labelModelname);
		listPaneAusgabe.add(tf_modelname);
		listPaneAusgabe.add(labelModelnummer);
		listPaneAusgabe.add(tf_modelversion);
		listPaneAusgabe.add(labelSpeicherort);
		listPaneAusgabe.add(tf_path);
		

		listPaneWagrecht.setLayout(new BoxLayout(listPaneWagrecht,	BoxLayout.LINE_AXIS));
		listPaneWagrecht.add(listPane1);
		listPaneWagrecht.add(listPane2);
		listPaneWagrecht.add(listPane3);
		listPaneWagrecht.add(listPane4);
		listPane.add(listPaneWagrecht);
		listPane.add(listPaneAusgabe);

		//Ausgabe der Boxen die fuer die Selektion der Klassen, Properties und Instanzen zustaendig sind.		
		JPanel listPaneWagrecht2 = new JPanel();
		listPaneWagrecht2.setAlignmentY(TOP_ALIGNMENT);
		listPaneWagrecht2.setLayout(new BoxLayout(listPaneWagrecht2, BoxLayout.LINE_AXIS));
		
		JPanel listPanewag1 = new JPanel();
		listPanewag1.setAlignmentY(TOP_ALIGNMENT);
		listPanewag1.setLayout(new BoxLayout(listPanewag1, BoxLayout.PAGE_AXIS));
		listPanewag1.add(new JLabel("Classes:"));

		JPanel listPanewag15 = new JPanel();
		listPanewag15.setAlignmentY(TOP_ALIGNMENT);
		listPanewag15.setLayout(new BoxLayout(listPanewag15, BoxLayout.PAGE_AXIS));
		listPanewag15.add(new JLabel("          "));

		JPanel listPanewag2 = new JPanel();
		listPanewag2.setAlignmentY(TOP_ALIGNMENT);
		listPanewag2.setLayout(new BoxLayout(listPanewag2, BoxLayout.PAGE_AXIS));
		listPanewag2.add(new JLabel("Properties:"));
		
		JPanel listPanewag25 = new JPanel();
		listPanewag25.setAlignmentY(TOP_ALIGNMENT);
		listPanewag25.setLayout(new BoxLayout(listPanewag25, BoxLayout.PAGE_AXIS));
		listPanewag25.add(new JLabel("          "));

		JPanel listPanewag3 = new JPanel();
		listPanewag3.setAlignmentY(TOP_ALIGNMENT);
		listPanewag3.setLayout(new BoxLayout(listPanewag3, BoxLayout.PAGE_AXIS));
		listPanewag3.add(new JLabel("Individuals:"));

		
		final JList<ListItem> mylist = new JList<ListItem>(listModel);
		mylist.setCellRenderer(new IconListRenderer());
		mylist.setVisibleRowCount(4);
		mylist.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		final JList<ListItem> mylistProperties = new JList<ListItem>(listModelProperties);
		mylistProperties.setCellRenderer(new IconListRenderer());
		mylistProperties.setVisibleRowCount(4);
		mylistProperties.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		final JList<ListItem> mylistIndividuals = new JList<ListItem>(listModelIndividual);
		mylistIndividuals.setCellRenderer(new IconListRenderer());
		mylistIndividuals.setVisibleRowCount(4);
		mylistIndividuals.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		
		JScrollPane pane = new JScrollPane(mylist);
		JScrollPane paneProberties = new JScrollPane(mylistProperties);
		JScrollPane paneIndividuals = new JScrollPane(mylistIndividuals);
		
		//Button fuer den Pfad zum auswaehlen
		browse.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JFileChooser fc = new JFileChooser();
		        FileNameExtensionFilter filter = new FileNameExtensionFilter(
		          "XML Files", new String[] { "xml" });
		        fc.setFileFilter(filter);
		        int retval = fc.showSaveDialog(tf_path);
		        if (retval == 0)
		        {
		          String temp = fc.getSelectedFile().getAbsolutePath();
		          if (!temp.endsWith(".xml")) {
		            temp = temp + ".xml";
		          }
		          tf_path.setText(temp);
				
		        }
			}
		});
		listPaneAusgabe.add(browse);
		
		// Button fuer das Speichern der aktuell Selektierten Werte
		button4.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {

				List<ListItem> werte = mylist.getSelectedValuesList();
				for (int d = 0; d < werte.size(); ++d) {
					for (int i = 0; i < listModel.getSize(); ++i) {
						if (myarrayList.get(i).toString().equals(werte.get(d).toString())) {
							myarrayList.get(i).setSelected(true);
						}
					}
				}
				
				
				List<ListItem> werteproberties = mylistProperties.getSelectedValuesList();
				for (int d = 0; d < werteproberties.size(); ++d) {
					for (int i = 0; i < listModelProperties.getSize(); ++i) {
						if (myarrayListProperties.get(i).toString().equals(werteproberties.get(d).toString())) {
							myarrayListProperties.get(i).setSelected(true);
						}
					}
				}
				
				
				List<ListItem> werteindividuals = mylistIndividuals.getSelectedValuesList();
				for (int d = 0; d < werteindividuals.size(); ++d) {
					for (int i = 0; i < listModelIndividual.getSize(); ++i) {
						if (myarrayListIndivduals.get(i).toString().equals(werteindividuals.get(d).toString())) {
							myarrayListIndivduals.get(i).setSelected(true);
						}
					}
				}
				repaint();
			}
		});
		listPane3.add(button4);

		// Unselektiertes Speichern
		button5.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				List<ListItem> werte = mylist.getSelectedValuesList();
				for (int d = 0; d < werte.size(); ++d) {
					for (int i = 0; i < listModel.getSize(); ++i) {
						if (!myarrayList.get(i).toString()
								.equals(werte.get(d).toString())) {
							myarrayList.get(i).setSelected(true);
						}
					}
				}
				
				List<ListItem> werteproberties = mylistProperties.getSelectedValuesList();
				for (int d = 0; d < werteproberties.size(); ++d) {
					for (int i = 0; i < listModelProperties.getSize(); ++i) {
						if (!myarrayListProperties.get(i).toString()
								.equals(werteproberties.get(d).toString())) {
							myarrayListProperties.get(i).setSelected(true);
						}
					}
				}
				
				List<ListItem> werteindividuals = mylistIndividuals.getSelectedValuesList();
				for (int d = 0; d < werteindividuals.size(); ++d) {
					for (int i = 0; i < listModelIndividual.getSize(); ++i) {
						if (!myarrayListIndivduals.get(i).toString()
								.equals(werteindividuals.get(d).toString())) {
							myarrayListIndivduals.get(i).setSelected(true);
						}
					}
				}
				repaint();
			}
		});
		listPane3.add(button5);

		// Selektiertes Loeschen
		button6.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				List<ListItem> werte = mylist.getSelectedValuesList();
				for (int d = 0; d < werte.size(); ++d) {
					for (int i = 0; i < listModel.getSize(); ++i) {
						if (myarrayList.get(i).toString()
								.equals(werte.get(d).toString())) {
							myarrayList.get(i).setSelected(false);
						}
					}
				}
				
				List<ListItem> werteproberties = mylistProperties.getSelectedValuesList();
				for (int d = 0; d < werteproberties.size(); ++d) {
					for (int i = 0; i < listModelProperties.getSize(); ++i) {
						if (myarrayListProperties.get(i).toString()
								.equals(werteproberties.get(d).toString())) {
							myarrayListProperties.get(i).setSelected(false);
						}
					}
				}
				
				List<ListItem> werteindividuals = mylistIndividuals.getSelectedValuesList();
				for (int d = 0; d < werteindividuals.size(); ++d) {
					for (int i = 0; i < listModelIndividual.getSize(); ++i) {
						if (myarrayListIndivduals.get(i).toString()
								.equals(werteindividuals.get(d).toString())) {
							myarrayListIndivduals.get(i).setSelected(false);
						}
					}
				}
				repaint();
			}
		});
		listPane4.add(button6);

		// Unselektiert Loeschen
		button7.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				List<ListItem> werte = mylist.getSelectedValuesList();

				for (int d = 0; d < werte.size(); ++d) {
					for (int i = 0; i < listModel.getSize(); ++i) {
						if (!myarrayList.get(i).toString()
								.equals(werte.get(d).toString())) {
							myarrayList.get(i).setSelected(false);
						}
					}
				}
				List<ListItem> werteproberties = mylistProperties.getSelectedValuesList();

				for (int d = 0; d < werteproberties.size(); ++d) {
					for (int i = 0; i < listModelProperties.getSize(); ++i) {
						if (!myarrayListProperties.get(i).toString()
								.equals(werteproberties.get(d).toString())) {
							myarrayListProperties.get(i).setSelected(false);
						}
					}
				}
				
				
				List<ListItem> werteindividuals = mylistIndividuals.getSelectedValuesList();

				for (int d = 0; d < werteindividuals.size(); ++d) {
					for (int i = 0; i < listModelIndividual.getSize(); ++i) {
						if (!myarrayListIndivduals.get(i).toString()
								.equals(werteindividuals.get(d).toString())) {
							myarrayListIndivduals.get(i).setSelected(false);
						}
					}
				}
				repaint();
			}
		});
		listPane4.add(button7);

		// Select All
		button2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				mylist.setSelectionInterval(0, mylist.getModel().getSize() - 1);
				mylistProperties.setSelectionInterval(0, mylistProperties.getModel().getSize() - 1);
				mylistIndividuals.setSelectionInterval(0, mylistIndividuals.getModel().getSize() - 1);
			}
		});
		listPane2.add(button2);

		// DeSelect All
		button3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				mylist.clearSelection();
				mylistProperties.clearSelection();
				mylistIndividuals.clearSelection();
			}
		});
		listPane2.add(button3);

		// Export
		button8.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				// Bitte warten fenster aufmachen
				JFrame fr_wait = new JFrame("Please wait...");
				JLabel l_wait = new JLabel("Please wait. Export in progress.", 0);
				l_wait.setFont(new Font("times", 1, 15));
				fr_wait.add(l_wait);
				fr_wait.pack();
				fr_wait.setSize(fr_wait.getWidth() + 20, fr_wait.getHeight() + 20);
				fr_wait.setLocationRelativeTo(null);
				fr_wait.setEnabled(false);
				fr_wait.setVisible(true);
				try {
					
					// pruefen ob pfad und modelname gesetzt sind
					if ((Tab.this.tf_path.getText() == null)
							|| (Tab.this.tf_path.getText().equals(""))) {
						/*
						 * Kein Filename angegeben
						 */
//						System.out.println("Kein Pfad angegeben");

					}
					else{

						String modelname = Tab.this.tf_modelname.getText();
						String modelversion = Tab.this.tf_modelversion.getText();
						
						if ((modelname == null) || (modelname.equals(""))) {
							/*
							 * Kein Modelname angegeben
							 */
	//						System.out.println("Kein Modelname angegeben");
						}
						else{
	
						
	
							//selektierte klassen rausspeichern
							List<OWLClass> l_classes = new ArrayList<OWLClass>();
							for (int d = 0; d < myarrayList.size(); ++d) {
								if (myarrayList.get(d).selected) {
									l_classes.add(myarrayList.get(d).myitem);
								}
							}
							//selektierte properties rausspeichern
							List<OWLProperty> l_properties = new ArrayList<OWLProperty>();
							List<OWLAnnotationProperty> l_propertiesanno = new ArrayList<OWLAnnotationProperty>();
							for (int d = 0; d < myarrayListProperties.size(); ++d) {
								if (myarrayListProperties.get(d).selected) {
									if(myarrayListProperties.get(d).myitemprobanno != null){
										l_propertiesanno.add(myarrayListProperties.get(d).myitemprobanno);
									} 
									else if(myarrayListProperties.get(d).myitemprob != null){
										l_properties.add(myarrayListProperties.get(d).myitemprob);
										
									}							
								}
							}
							//selektierte Instanzen rausspeichern
							List<OWLIndividual> l_instances = new ArrayList<OWLIndividual>();
							for (int d = 0; d < myarrayListIndivduals.size(); ++d) {
								if (myarrayListIndivduals.get(d).selected) {
									l_instances.add(myarrayListIndivduals.get(d).myitemindividual);
								}
							}				
							

							//Export ausfuehren
							Tab.this.export = new DefaultExportImplementation();
							if (Tab.this.export.export(ontology, modelname, modelversion,
									Tab.this.tf_path.getText(),
									/*Tab.this.owlmodel.getNamespaceManager(),*/ prefixmanager,
									l_classes, l_properties, l_propertiesanno, l_instances
									/*l_alldifferent*/)) {
									System.out.println("Export successful");
							} else {
									System.out.println("Export failed");
							}
						}
					}
					fr_wait.setVisible(false);
					fr_wait.dispose();
					
				} catch (Exception e1) {
					e1.printStackTrace();
					fr_wait.setVisible(false);
					fr_wait.dispose();
					System.out.println("Error when exporting from SeMFIS plugin");
				}
			}
		});
		listPane5.add(button8);
		listPaneAusgabe.add(button8);

		listPanewag1.add(pane);
		listPanewag2.add(paneProberties);
		listPanewag3.add(paneIndividuals);
		
		
		listPaneWagrecht2.add(listPanewag1);
		listPaneWagrecht2.add(listPanewag15);
		listPaneWagrecht2.add(listPanewag2);
		listPaneWagrecht2.add(listPanewag25);
		listPaneWagrecht2.add(listPanewag3);

		listPane.add(listPaneWagrecht2);
		add(listPane);
		log.info("Example View Component initialized");
	}

	@Override
	protected void disposeOWLView() {
		// metricsComponent.dispose();
	}

}

